> For the complete documentation index, see [llms.txt](https://docs.nucleusearn.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nucleusearn.io/nucleus-architecture/smart-contracts/contracts/atomic-queue/atomicsolver.md).

# AtomicSolver

[Git Source](https://github.com/Ion-Protocol/nucleus-boring-vault/blob/cc0b494b83e17b9b169a73b96050d2810b690477/src/atomic-queue/AtomicSolver.sol)

**Inherits:** IAtomicSolver, Owned, ERC721Holder

**Author:**

## State Variables

### \_solving

```solidity
bool private _solving;
```

### \_balancerVault

```solidity
address private immutable _balancerVault;
```

### approvedToCallFinishSolve

```solidity
mapping(address => bool) private approvedToCallFinishSolve;
```

## Functions

### constructor

```solidity
constructor(address _owner, address _vault) Owned(_owner);
```

### updateMapping

```solidity
function updateMapping(address who, bool state) external onlyOwner;
```

### finishSolve

```solidity
function finishSolve(
    bytes calldata runData,
    address initiator,
    ERC20,
    ERC20 want,
    uint256,
    uint256 assetsForWant
)
    external;
```

### doStuff

```solidity
function doStuff(
    address[] calldata targets,
    uint256[] calldata values,
    bytes[] calldata ammo
)
    external
    payable
    onlyOwner;
```

### receiveFlashLoan

```solidity
function receiveFlashLoan(
    address[] calldata tokens,
    uint256[] calldata amounts,
    uint256[] calldata feeAmounts,
    bytes calldata userData
)
    external;
```

### getEth

```solidity
function getEth(address payable receiver) external onlyOwner;
```

### receive

```solidity
receive() external payable;
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nucleusearn.io/nucleus-architecture/smart-contracts/contracts/atomic-queue/atomicsolver.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
